Jqpress.Web/Areas/Admin/Controllers/UserController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Jqpress.Framework.Web;
using Jqpress.Framework.Utils;
using Jqpress.Core.Services;
using Jqpress.Core.Domain;
using Jqpress.Web.Areas.Admin.Models;

namespace Jqpress.Web.Areas.Admin.Controllers
{
    public class UserController : BaseAdminController
    {
        #region private items
        private UserService _userService = new UserService();
        #endregion;
        public ActionResult List()
        {
            var model = new UserListModel();


            List<UserInfo> list = _userService.GetUserList();
            model.UserList = list;
           

            return View(model);
        }

        /// <summary>
        /// get user by id
        /// </summary>
        public ActionResult Edit(int? id)
        {
            var uid = id ?? 0;
            var model =new UserModel();

            model.RolesCateItem = LoadRole(0);
            if (uid > 0) 
            {
                model.user = _userService.GetUser(uid);
                model.RolesCateItem = LoadRole(model.user.Role);
            }
            return View(model);
        }
        private List<SelectListItem> LoadRole(int id) 
        {
            var dic = new Dictionary<string, string>();
            dic.Add("1", "管理员");
            dic.Add("2", "编辑");
            dic.Add("3", "订阅者");
            dic.Add("4", "投稿者");
            dic.Add("5", "作者");
            var list = new List<SelectListItem>();
            foreach (int role in Enum.GetValues(typeof(Jqpress.Core.Domain.Enum.UserRole)))
            {
                string name = Enum.GetName(typeof(Jqpress.Core.Domain.Enum.UserRole), role);
                foreach (KeyValuePair<string, string> kv in dic)
                {
                    if (id == Convert.ToInt32(kv.Key))
                    {
                        var Item = new SelectListItem() { Text = kv.Value, Value = role.ToString(),Selected =true };
                        list.Add(Item);
                    }
                    else 
                    {
                        var Item = new SelectListItem() { Text = kv.Value, Value = role.ToString() };
                        list.Add(Item);
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// delete user by id
        /// </summary>
        public ActionResult Delete(int? id)
        {
            var uid = id ?? 0;
            _userService.DeleteUser(uid);
            SuccessNotification("删除成功");
            return RedirectToAction("list");
        }
        /// <summary>
        /// insert or update user
        /// </summary>
        /// <param name="u"></param>
        /// <returns></returns>
        [HttpPost, ActionName("Save"), ValidateInput(false)]
        public ActionResult Save(UserInfo u)
        {
            var password2 = Request.Form["password2"];

            var flag = true;
            if (!string.IsNullOrEmpty(u.Password) && u.Password != password2)
            {
                ErrorNotification("两次密码输入不相同!");
                flag = false;
            }
            else 
            {
                if (!string.IsNullOrEmpty(u.Password)) 
                {
                    u.Password = EncryptHelper.MD5(u.Password);                
                }
            }

            if (u.UserId > 0)
            {
                var olduser = _userService.GetUser(u.UserId);
                u.CreateTime = olduser.CreateTime;
                u.CommentCount = olduser.CommentCount;
                u.PostCount = olduser.PostCount;
                if (string.IsNullOrEmpty(u.Password)) 
                {
                    u.Password = olduser.Password;
                }
            }
            else
            {
                u.CommentCount = 0;
                u.CreateTime = DateTime.Now;
                u.PostCount = 0;
            }
            u.SiteUrl = string.Empty;
            u.AvatarUrl = string.Empty;
            u.Description = string.Empty;
            u.Status = 1;


            #region 验证处理
            if (string.IsNullOrEmpty(u.UserName))
            {
                ErrorNotification("请输入登陆用户名!");
                flag = false;
            }

            System.Text.RegularExpressions.Regex reg = new System.Text.RegularExpressions.Regex("[A-Za-z0-9\u4e00-\u9fa5-]");
            if (!reg.IsMatch(u.UserName))
            {
                ErrorNotification("用户名限字母,数字,中文,连字符!");
                flag = false;
            }
            #endregion

            if (u.UserId>0)//更新操作
            {
                if (flag)
                {
                    _userService.UpdateUser(u);
                    //  如果修改当前用户,则更新COOKIE
                    if (!string.IsNullOrEmpty(u.Password) && u.UserId == CurrentUserId)
                    {
                       _userService.WriteUserCookie(u.UserId, u.UserName, u.Password, 0);
                    }
                    SuccessNotification("修改成功");
                    return RedirectToAction("list");
                }
                else 
                {
                    return RedirectToAction("edit", new { id=u.UserId});                   
                }
            }
            else//添加操作
            {

                if (string.IsNullOrEmpty(u.Password))
                {
                    ErrorNotification("请输入密码!");
                    flag = false;
                }
                if (_userService.ExistsUserName(u.UserName))
                {
                    ErrorNotification("该用户名已存在,请换之");
                    flag = false;
                }
                if (flag)
                {
                    u.UserId = _userService.InsertUser(u);
                    SuccessNotification("添加成功");
                    return RedirectToAction("list");
                }
                else 
                {
                    return RedirectToAction("edit");
                }

            }
        }
    }
}

Jqpress.Web/Areas/Admin/Views/User/Edit.cshtml
@using Jqpress.Framework.Mvc
@using Jqpress.Framework.Web;
@model Jqpress.Web.Areas.Admin.Models.UserModel
@{
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
    ViewBag.Title = Model.user.UserId > 0 ? "编辑用户 - 管理中心 - Powered by Jqpress" : "添加用户 - 管理中心 - Powered by Jqpress";
}

<!-- BEGIN PAGE HEADER-->
<div class="row">
<div class="col-md-12">
    <!-- BEGIN PAGE TITLE & BREADCRUMB-->
    <h3 class="page-title">
        @(Model.user.UserId > 0 ? "编辑" : "添加")用户 
    </h3>
    <!-- END PAGE TITLE & BREADCRUMB-->
</div>
</div>
<!-- END PAGE HEADER-->



 @Html.JPartial("_Notifications")


<div class="portlet-body form">
    <form name="form1" method="post" action="@Url.Action("Save", "User")"  >
    <input type="hidden"  id="UserId" name="UserId" value="@Model.user.UserId" />

    <div class="form-body">
                           
        <div class="form-group">
                 <label  >角色：</label>
                 @Html.DropDownList("Role", Model.RolesCateItem, new { @class = "form-control input-medium" })
        </div>
        <style>
         label{width:70px;}
        </style>
        <div class="form-group">
        <label  >用户名：</label>
        <input type="text"  id="UserName" name="UserName" value="@Model.user.UserName"  class="form-control"  style="width:20%"/>(字母,数字,中文,连字符)
        </div>
        <div class="form-group">
        <label >昵称：</label>
        <input type="text" id="NickName" name="NickName" value="@Model.user.NickName"  class="form-control"   style="width:20%"/>
        </div>
        <div class="form-group">
        <label  >密码：<span class="small gray"></span></label>
        <input type="password" value="" id="Password" name="Password" class="form-control"  style="width:20%"/>
        </div>

        <div class="form-group">
        <label >确认密码：<span class="small gray"></span></label>
        <input type="password" value="" id="Password2" name="Password2" class="form-control"  style="width:20%"/>
        </div>

        <div class="form-group" >
           <label  >邮箱：</label>
        <input type="text"  id="Email" name="Email"  value="@Model.user.Email"  class="form-control"  style="width:20%"/>
        </div>
  
                         
        <div class="form-group">
            <button type="submit" name="btnEdit"  onclick="return checkForm();" id="btnEdit" class="btn btn-primary" >@(Model.user.UserId > 0 ? "修改" : "添加")</button>
            <button type="button" class="btn btn-default" onclick="history.go(-1)" >返回 </button>
        </div>


    </div>
                        
    </form>


</div>

Jqpress.Web/Areas/Admin/Views/User/List.cshtml
@using Jqpress.Framework.Mvc
@model Jqpress.Web.Areas.Admin.Models.UserListModel
@{
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
    ViewBag.Title = "用户列表 - 管理中心 - Powered by Jqpress";
}
<script type="text/javascript">
    $(document).ready(function () {
        ///全选
        $("#checkAll").click(function () {
            if (this.checked) {
                $("input[name='chkid']").attr("checked", true);
            } else {
                $("input[name='chkid']").attr("checked", false);
            }
        });

    });

    //修改操作
    function getJsonData(id) {
        $.getJSON('@Url.Action("Edit", "User",new{dt=DateTime.Now})',{id:id}, function (json) {
            $("#UserName").val(json.UserName);
            $("#NickName").val(json.NickName);
            $("#Password").val("");
            $("#Password2").val("");
            $("#Email").val(json.Email);
            $("#UserId").val(json.UserId);
            $("input[name='Status']").attr("checked", json.Status ==1? true:false);
            $("#submit").val("修改");
            $(".formzone").show("slow");
        });
    }
    //删除操作
    function deleteRow(id) {
        if (confirm('确定要删除此用户吗?')) {
            $.ajax({
                url: '@Url.Action("Delete", "User",new{dt=DateTime.Now})',
                data: { id: id },
                success: function (msg) {
                    $("#row" + id).fadeOut(500);
                }
            });
        }
    }

    $(document).ready(function () {
        //初始化表单
        function InitForm() {
            $(':text').each(function (i, n) { n.value = ''; });
            $('#UserId').each(function (i, n) { n.value = ''; });
            $("#submit").val("添加");
        }

        //添加事件
        $("#addbtn").click(function () {
            if ($(".formzone").css("display") == "none") {
                InitForm();
                $(".formzone").show("slow");
            } else {
                $(".formzone").hide("slow");
            }
        });
        //绑定删除事件
        $(".row td .delete").bind("click", function () { deleteRow(this.id); });
        //绑定修改事件
        $(".row td .edit").bind("click", function () { getJsonData(this.id) });

        //取消事件
        $("#btncancle").click(function () {
            if ($(".formzone").css("display") == "none") {
                InitForm();
                $(".formzone").show("slow");
            } else {
                $(".formzone").hide("slow");
            }
        });
        //保存事件
        $('#form1').submit(function () {
            if ($("#UserName").val() == '') { return; }
            var act = "add";
            if ($("#UserId").val() != '') { act = "update"; }

            jQuery.ajax({
                type: 'POST', // 设置请求类型为 ‘POST’，默认为 ‘GET’
                url: '@Url.Action("Save", "User",new{dt=DateTime.Now})', //
                data: $('#form1').serialize(), // 从表单中获取数据  
                beforeSend: function () { },
                error: function (XMLHttpRequest, textStatus, errorThrown) { alert(textStatus); },
                dataType: 'json',
                success: function (data) {
                    if (data.UserId == undefined) { alert(data); return; }

                    var _tr = "<tr class='row' style='background:#FFECC6' id='row" + data.UserId + "'>";
                    _tr += " <td>" + data.Link + "</td>";
                    _tr += " <td>" + data.PostCount + "/" + data.CommentCount + "</td>";
                    _tr += " <td>" + (data.Status == "1" ? "可用" : "不可用") + "</td>";
                    _tr += " <td>" + data.RoleDisplay + "</td>";
                    _tr += "<td><a class='edit' href='javascript:getJsonData(" + data.UserId + ")' id='" + data.UserId + "'>编辑</a> <a class='delete' href='javascript:deleteRow(" + data.UserId + ")'  id='" + data.UserId + "'>删除</a></td>";
                    _tr += "</tr>";
                    InitForm();
                    $(".formzone").hide("slow");

                    if (act == "update") {
                        $("#row" + data.UserId).replaceWith(_tr);
                    } else {
                        $("#sample_1").append(_tr);
                        $(".total strong").text(parseInt($(".total strong").text()) + 1)
                    }

                }
            });
            return false;
        });


    });
 
</script>

<!-- BEGIN PAGE HEADER-->
<div class="row">
<div class="col-md-12">
    <!-- BEGIN PAGE TITLE & BREADCRUMB-->
    <h3 class="page-title">
        用户管理 <small><a href="@Url.Action("Edit", "User")" class="btn btn-sm btn-link">添加 <i class="icon-plus"></i></a></small>
    </h3>
    <!-- END PAGE TITLE & BREADCRUMB-->
</div>
</div>
<!-- END PAGE HEADER-->
 @Html.JPartial("_Notifications")
 <form id="form1" action="">


    <table class="table table-striped table-bordered table-hover" id="sample_1">
                        <thead>
                           <tr>
                              <th class="table-checkbox"><input type="checkbox" class="group-checkable" data-set="#sample_1 .checkboxes" /></th>
                            <th>用户名</th>
                            <th>昵称</th>
                            <th>文章/评论</th>
                            <th>状态</th>
                            <th>角色</th>
                            <th>操作</th>
                           </tr>
                        </thead>
                        <tbody>

                              @foreach (var item in Model.UserList)
                             {
		                              <tr id="post@(item.UserId)" class="odd gradeX">
			                            <td><input type="checkbox" name="chkid" value="@item.UserId" /> </td>
			                            <td>
			                               @(item.UserName)
			                            </td>
                                        <td>
			                               @(item.NickName)
			                            </td>
			                            <td> @(item.PostCount)/@item.CommentCount</td>
			                            <td>@(item.Status==1?"可用":"不可用")</td>
			                            <td>@item.RoleDisplay</td>
			                            <td>
			  	                              	<span><a href="edit?id=@item.UserId"> 编辑 </a></span>
				                               <span><a  onclick="return confirm('删除用户不删除对应的文章,确定要删除吗?');" href="delete?id=@item.UserId"> 删除</a></span>
                                        </td>
		                              </tr>
                             }
                        </tbody>
                     </table>

</form>